<?php

	/*
	*	Gekko - Open Source Web Development Framework
	*	------------------------------------------------------------------------
	*	Copyright (C) 2004-2006, J. Carlos Nieto <xiam@users.sourceforge.net>
	*	This program is Free Software.
	*
	*	@package	Gekko
	*	@license	http://www.gnu.org/copyleft/gpl.html GNU/GPL License 2.0
	*	@author		J. Carlos Nieto <xiam@users.sourceforge.net>
	*	@version	CVS: $Id: main.act.php,v 1.1.1.1 2006/02/20 21:52:24 xiam Exp $
	*	@link		http://www.gekkoware.org
	*/

	define ("IN-GEKKO", true);

	require_once "../../conf.php";

	LoadLib (
		"core.lib.php", "format.lib.php", "comments"
	);

	require_once GEKKO_ROOT."lib/auth.inc.php";

	varImport("action|", "id|", "return|");

	$auth_edit = false;

	// is this user authorized to edit messages?
	if (!is_admin() && !is_array($id)) {
		$db->query("SELECT id, creationtime, userid FROM ".db_table("comment")." WHERE id = '{$id}'");
		$row = $db->fetch_row();
		$auth_edit = Comments::authEdit($row);
	}

	switch ($action) {
		case "delete":
			if (is_admin() || $auth_edit)
				execWithEach($id, "comments::deleteItem");
			else
				abort(accessDenied());
		break;
		case "post":

			// antiflood
			$AccessTable->load_rule (
				$AccessTable->set_generic_rule("comments", "post"),
				"E_ANTI_FLOOD"
			);

			varImport("thread", "parent|0", "module", "nickname|", "email|", "title|", "icon|", "content", "url|");

			varRequire("thread", "module", "title", "content");

			if (Comments::allowComment($module, $thread)) {

				rtb_codefix($content);

				$db->query ("
				INSERT INTO ".db_table("comment")."
					(
						id,
						module,
						thread,
						parent,
						userid,
						nickname,
						url,
						email,
						icon,
						title,
						content,
						creationtime,
						ipaddr
					)
						VALUES
					(
						'".$db->free_id("comment")."',
						'{$module}',
						'{$thread}',
						'{$parent}',
						'{$USER["id"]}',
						'{$nickname}',
						'{$url}',
						'{$email}',
						'{$icon}',
						'{$title}',
						'{$content}',
						'".time()."',
						'".IP_ADDR."'
					)
				", __FILE__, __LINE__);

				gcookie("nickname", $nickname);
				gcookie("email", $email);
				gcookie("url", $url);
			}

			slog("comments: posted from ".getIP().", thread: $module.$thread.$parent", "actions", 3);
		break;
		case "edit":
			if (is_admin() || $auth_edit) {

				varImport("id", "thread", "module", "nickname", "email", "title", "icon", "content");

				varRequire("id", "thread", "module", "title", "content");

				rtb_codefix($content);

				$db->query("
					UPDATE ".db_table("comment")." SET
						".(is_admin() ? "nickname = '{$nickname}'," : "")."
						".(is_admin() ? "email = '{$email}'," : "")."
						icon = '{$icon}',
						title = '{$title}',
						content = '{$content}'
					WHERE id = '{$id}' ".(is_admin() ? "" : " AND userid = '{$USER["id"]}'")."
				", __FILE__, __LINE__);

				slog("comment: modified comment '$id'", "actions", 2);
			} else {
				abort(accessDenied());
			}
		break;
		default:
			abort(_l("L_UNDEFINED_ACTION"));
		break;
	}

	redirect($return);

	db_exit();
?>