<?php

	/*
	*	Gekko - Open Source Web Development Framework
	*	------------------------------------------------------------------------
	*	Copyright (C) 2004-2006, J. Carlos Nieto <xiam@users.sourceforge.net>
	*	This program is Free Software.
	*
	*	@package	Gekko
	*	@license	http://www.gnu.org/copyleft/gpl.html GNU/GPL License 2.0
	*	@author		J. Carlos Nieto <xiam@users.sourceforge.net>
	*	@version	CVS: $Id: main.inc.php,v 1.1.1.1 2006/02/20 21:52:24 xiam Exp $
	*	@link		http://www.gekkoware.org
	*/

	if (!defined("IN-GEKKO")) die("Get a life!");

	LoadLib (
		"users", "comments", "format.lib.php"
	);

	Extract (
		UrlGetArgs("null/action=alpha?id=int&page=page")
	);

	switch ($action) {
		case "permalink":
			if ($id) {
				$db->query("SELECT module, thread, creationtime FROM ".db_table("comment")."
				WHERE id='{$id}'", __FILE__, __LINE__);

				if ($db->num_rows()) {

					$row = $db->fetch_row();

					$maxitems = conf::getKey("comments", "items_per_page");

					$q = $db->query("SELECT id FROM ".db_table("comment")."
					WHERE module='{$row["module"]}' AND thread='{$row["thread"]}'
					AND parent = '0' AND creationtime < '{$row["creationtime"]}'",
					__FILE__, __LINE__);

					$page = ($db->num_rows($q)+1)/$maxitems;

					if ($page > intval($page))
						$page = intval(++$page);

					abort(redirect(urlevalprototype("index.php/module={$row["module"]}/action=view?id={$row["thread"]}&page=$page#c$id", true, false)));

				} else {
					abort("Unknown link.");
				}
			}
		break;
		case "edit":
			if ($id) {

				$db->query ("
				SELECT
					id, module, thread, icon, title, url, content, nickname, email, userid, creationtime
				FROM ".db_table("comment")." WHERE id = '{$id}'
				", __FILE__, __LINE__);

				$tpl = new ContentBlock();

				$tpl->insert("BLOCK_CONTENT", "comments/comment.form.tpl");

				if (($db->num_rows() && $row = $db->fetch_row())  && Comments::authEdit($row)) {

					saneHTML($row, "content");

					$filter = new GekkoHtmlFilter(cache_func("Users::fetchInfo", $row["userid"], "groups"));
					$row["content"] = $filter->applyFilters($row["content"]);

					$tpl->set_arr($row);

					$tpl->set_arr (
						Array (
							"BLOCK_ICON"			=> mkIcon("comments.png"),
							"BLOCK_TITLE"			=> _l("L_COMMENTS"),
							"COMMENT_FORM_TITLE"	=> _l("L_EDIT_COMMENT"),
							"ACTION"				=> "edit",
							"RETURN"				=> local_referer(),
							"EDIT_AUTHOR"			=> true
						)
					);

					$mcBuff = $tpl->make();
				} else {
					$mcBuff = accessDenied();
				}
			}

		break;
		case "view":
			if ($id) {

				$db->query ("
				SELECT
					id, userid, nickname, email, icon, url, title, content, creationtime, ipaddr
				FROM ".db_table("comment")." WHERE id = '{$id}'
				", __FILE__, __LINE__);

				if ($db->num_rows()) {
					$row = $db->fetch_row();

					Comments::prepareRow($row);
					$row["buttons"] = Comments::mkbuttonbox($row["id"], Comments::authEdit($row), false);

					$tpl = new ContentBlock();
					$tpl->insert("BLOCK_CONTENT", "comments/comment.tpl");

					// loading children
					$children = Comments::fetchChildren($row["id"]);

					foreach ($children as $child) {
						Comments::prepareRow($child);
						$child["buttons"] = Comments::mkbuttonbox($child["id"], Comments::authEdit($child), false);

						$tpl->set_arr($child, "COMMENT.REPLY");
						$tpl->saveBuff("COMMENT.REPLY");
					}

					$tpl->set_arr($row, "COMMENT");

					$tpl->set_arr (
						Array (
							"BLOCK_TITLE"		=> _l("L_COMMENTS"),
							"BLOCK_ICON"		=> mkicon("comments.png"),
							"COMMENTS_TITLE"	=> _l("L_VIEW_COMMENT")
						)
					);

					$tpl->saveBuff("COMMENT");

					$mcBuff = $tpl->make();
				}
			}
		break;
		default: {
			$buff = new BlockWidget();
			$buff->load("comments/comment.tpl");
			$buff->vren("COMMENTS", "LAST_COMMENTS");

			$pager = $db->pager(
				"SELECT id FROM ".db_table("comment")." WHERE parent='0'",
				"index.php/module=comments?id=%p", $page, conf::getkey("comments", "items_per_page")
			);

			$db->query ("
				SELECT
					id, module, thread, userid, nickname, email, url, icon, title, content, creationtime, ipaddr
				FROM ".db_table("comment")." WHERE parent='0'
				ORDER BY creationtime DESC ".$pager["sql"]."
			", __FILE__, __LINE__);

			if ($db->num_rows()) {
				while ($row = $db->fetch_row()) {

					Comments::prepareRow($row);
					$row["buttons"] = Comments::mkbuttonbox($row["id"], Comments::authEdit($row), false);
					$row["title"]= mkLink("index.php/module={$row["module"]}/action=view?id={$row["thread"]}", $row["title"]);

					$buff->set_arr($row, "COMMENT");
					$buff->saveBuff("COMMENT");
				}

				$buff = $buff->make();
				$buff .= $pager["html"];

				$mcBuff = $buff;
			}
		}
	}

?>