<?php

	/*
	*	Gekko - Open Source Web Development Framework
	*	------------------------------------------------------------------------
	*	Copyright (C) 2004-2006, J. Carlos Nieto <xiam@users.sourceforge.net>
	*	This program is Free Software.
	*
	*	@package	Gekko
	*	@license	http://www.gnu.org/copyleft/gpl.html GNU/GPL License 2.0
	*	@author		J. Carlos Nieto <xiam@users.sourceforge.net>
	*	@version	CVS: $Id: main.lib.php,v 1.1.1.1 2006/02/20 21:52:24 xiam Exp $
	*	@link		http://www.gekkoware.org
	*/

	if (!defined("IN-GEKKO")) die("Get a life!");

	Class Comments {

		function LoadBlock($module, $thread, $url, $page = 1, $title = null) {

			$comm = "";
			$comm .= Comments::loadThread($module, $thread, $url, $page);
			$comm .= Comments::loadForm($module, $thread, $title);

			if ($comm) {
				$tpl = new ContentBlock();
				$tpl->set_arr (
					Array (
						"BLOCK_TITLE"	=> _l("L_COMMENTS"),
						"BLOCK_ICON"	=> mkIcon("comments.png", 16),
						"BLOCK_CONTENT"	=> $comm
					)
				);
				return $tpl->make();
			} else {
				// comments are disabled
				return "";
			}
		}

		function countItems($module, $thread, $only_parents = false) {
			$db =& $GLOBALS["db"];
			$q = $db->query("SELECT id FROM ".db_table("comment")."
			WHERE module = '{$module}' AND thread = '{$thread}'".($only_parents ? " AND parent='0'": "")."", __FILE__, __LINE__,true);
			return intval($db->num_rows($q));
		}


		function deleteItems($module, $thread) {
			$db =& $GLOBALS["db"];

			$q = $db->query("SELECT id FROM ".db_table("comment")." WHERE module='{$module}' AND thread='{$thread}'",
			__FILE__, __LINE__, true);

			while ($row = $db->fetch_row($q))
				comments::deleteItem($row["id"]);

			slog("comments: massive deletion (module=$module thread=$thread)", "actions", 2);
		}


		function mkLink($module, $thread, $url_prototype = null) {
			/* comments are enabled? */
			if (!Conf::getKey($module, "allow_user_comments", 0, "b"))
				return _l("L_COMMENTS_DISABLED");
			$c = Comments::countItems($module, $thread);
			return mkLink(($url_prototype ? $url_prototype : "index.php/module=$module/action=view?id=$thread")."#comment", ($c ? _l("L_COMMENTS").": $c" : _l("L_POST_A_COMMENT")));
		}


		function deleteItem($id) {
			slog("comments: comment '$id' was deleted", "actions", 1);
			Comments::deleteChildren($id);
			return $GLOBALS["db"]->query ("DELETE FROM ".db_table("comment")." WHERE id='{$id}'", __FILE__, __LINE__, true);
		}


		function deleteChildren($id) {
			if ($id) {
				$db =& $GLOBALS["db"];
				$q = $db->query("SELECT id FROM ".db_table("comment")." WHERE parent='{$id}'", __FILE__, __LINE__, true);
				while ($row = $db->fetch_row($q)) {
					comments::deleteItem($row["id"]);
				}
			}
		}

		function loadForm($module, $thread, $title = null, $data = null) {
			$buff = "";
			if (Comments::allowComment($module, $thread)) {
				$tpl = $GLOBALS["T"];
				$buff = $tpl->load("comments/comment.form.tpl");

				if (!$data) {
					$data = Array (
						"V_THREAD"				=> "$thread",
						"V_MODULE"				=> "$module",
						"V_ACTION"				=> "post",
						"V_TITLE"				=> "Re: $title",
						"V_CONTENT"				=>  "",
						"V_COMMENT_FORM_TITLE"	=> _l("L_POST_A_COMMENT"),
						"V_RETURN"				=> "",
						"V_NICKNAME"			=> htmlspecialchars(rcookie("nickname")),
						"V_EMAIL"				=> htmlspecialchars(rcookie("email")),
						"V_URL"					=> htmlspecialchars(rcookie("url"))
					);
				}
				$buff = $tpl->make($tpl->parse($buff, $data, true));
			}
			return $buff;
		}

		function authEdit(&$row) {
			return (gauth("comment") || (is_user() && ($row["userid"] == $GLOBALS["USER"]["id"]) && ($row["creationtime"]+conf::getKey("comments", "edit_time")) >= time()));
		}

		function fetchChildren($parent, $level = 0) {
			$result = Array();
			$level++;

			$db =& $GLOBALS["db"];
			$q = $db->query("SELECT
				id, userid, nickname, email, icon, title, content, creationtime, ipaddr, url
				FROM ".db_table("comment")." WHERE parent='$parent'
			");

			while ($row = $db->fetch_row($q)) {
				$row["level"] = $level;
				$result[] = $row;

				// recursion
				if (($children = Comments::fetchChildren($row["id"], $level)))
					$result = array_merge($result, $children);
			}

			return $result;
		}

		function prepareRow(&$row) {

			saneHTML($row, "content");

			Format::Style($row["content"], $row["userid"]);

			$row["author"] = Comments::mkuserlink($row);
			$row["buttons"] = Comments::mkbuttonbox($row["id"], Comments::authEdit($row["id"]));

		}

		function loadThread($module, $thread, $url_prototype, $page = 1) {

			if (Comments::allowComment($module, $thread)) {

				$db =& $GLOBALS["db"];

				$buff = new BlockWidget();
				$buff->load("comments/comment.tpl");

				// creating pager
				$pager = $db->pager (
					"SELECT id FROM ".db_table("comment")."
					WHERE module = '{$module}' AND thread = '{$thread}' AND parent = '0'",
					$url_prototype, $page,
					conf::getKey("comments", "items_per_page")
				);

				// querying for messages
				$q = $db->query("
					SELECT
						id, userid, nickname, email, icon, title, content, url, creationtime, ipaddr
					FROM ".db_table("comment")."
					WHERE module = '{$module}' AND thread = '{$thread}' AND parent = '0'
					ORDER BY creationtime ASC ".$pager["sql"]."
				", __FILE__, __LINE__, true);

				if ($db->num_rows($q)) {

					while ($row = $db->fetch_row($q)) {

						Comments::prepareRow($row);

						$buff->set_arr($row, "COMMENT");

						// loading children
						$children = Comments::fetchChildren($row["id"]);
						$buff->reset("COMMENT.REPLY");

						foreach ($children as $child) {
							$buff->set("REPLIES", 1, "COMMENT");
							Comments::prepareRow($child);
							$buff->set_arr($child, "COMMENT.REPLY");
							$buff->saveBuff("COMMENT.REPLY");
						}

						$buff->saveBuff("COMMENT");
					}

					$buff->set ("COMMENTS_TITLE", "");

					$buff = $buff->make();

					$buff .= $pager["html"];

					return $buff;
				}
			}
			return false;
		}


		function mkUserLink($row) {

			if ($row["userid"]) {
				return cache_func("users::mkuserlink", $row["userid"]);
			} else {

				if (!gauth("comments") && conf::getkey("comments", "hide_ip_and_email", 1, "b"))
					$row["email"] = $row["ipaddr"] = "";

				if (!$row["nickname"])
					$row["nickname"] = _l("L_ANONYMOUS");

				if ($row["url"] == "http://")
					$row["url"] = "";

				return "&lt;".safeLink($row["url"], $row["nickname"])."&gt; ".($row["email"] ? " ".safelink($row["email"]) : "").($row["ipaddr"] ? " (".$row["ipaddr"].")" : "");
			}
		}

		function mkButtonBox($id, $editable = false, $reply = true) {
			$buttonBox = new tplButtonBox();
			if ($editable) {
				$buttonBox->add(mkLink("index.php/module=comments/action=edit?id={$id}", _l("L_EDIT"), "edit.png"));
				$buttonBox->add(mkLink("modules/comments/main.act.php?action=delete&id={$id}&auth={C_AUTH_STR}", _l("L_DELETE"), "delete.png", true));
			}
			if ($reply)
				$buttonBox->add(mkLink("javascript:commentReply({$id});", _l("L_REPLY"), "reply.png"));
			return $buttonBox->make();
		}
		function allowComment($module, $thread) {
			if (Conf::getKey($module, "allow_user_comments", 0, "b")) {

				LoadLib ($module);

				return call_user_func(array($module, "allowComment"), $thread);
			}
			return false;
		}
	}
?>